> Documentation index for AI agents: https://docs.pagerduty.com/llms.txt

# List Fields

`GET https://api.pagerduty.com/services/custom_fields`

List Custom Fields available for Services.

Scoped OAuth requires: `custom_fields.read`

## Authorization

- **api_key** (apiKey) — `Authorization` header. The API Key with format `Token token=<API_KEY>`

## Query parameters

| Name | Type | Required | Description |
|---|---|---|---|
| `include[]` | string |  | Array of additional details to include. One of: `field_options`. Items must be unique. |

## Header parameters

| Name | Type | Required | Description |
|---|---|---|---|
| `Accept` | string | yes | The `Accept` header is used as a versioning header. Default: `application/vnd.pagerduty+json;version=2`. |

## Response 200

A list of fields.

### `application/json`

| Field | Type | Required | Description |
|---|---|---|---|
| `fields` | array of object |  |  |
| `fields[].created_at` | string (date-time) |  | The date/time the object was created at. |
| `fields[].data_type` | string |  | The kind of data the custom field is allowed to contain. One of: `boolean`, `integer`, `float`, `string`, `datetime`, `url`. |
| `fields[].description` | string \| null |  | A description of the data this field contains. Max length: 1000. |
| `fields[].display_name` | string |  | The human-readable name of the field. This must be unique across an account. Max length: 50. |
| `fields[].enabled` | boolean |  | Whether the field is enabled. One of: `true`, `false`. |
| `fields[].field_options` | array of object |  | The options for the custom field. Applies only to `single_value_fixed` and `multi_value_fixed` field types. These options are returned only if the `include[]` parameter specifies `field_options`. |
| `fields[].field_options[].created_at` | string (date-time) |  | The date/time the object was created at. |
| `fields[].field_options[].data` | object |  |  |
| `fields[].field_options[].data.data_type` | string |  | The kind of data represented by this option. Must match the Field's `data_type`. One of: `string`. |
| `fields[].field_options[].data.value` | string |  | Max length: 200. |
| `fields[].field_options[].id` | string |  | The ID of the resource. |
| `fields[].field_options[].type` | string |  | One of: `field_option`. |
| `fields[].field_options[].updated_at` | string (date-time) |  | The date/time the object was updated at. |
| `fields[].field_type` | string |  | The type of data this field contains. In combination with the `data_type` field. One of: `single_value`, `single_value_fixed`, `multi_value`, `multi_value_fixed`. |
| `fields[].id` | string |  | The ID of the resource. |
| `fields[].name` | string |  | The name of the field. May include ASCII characters, specifically lowercase letters, digits, and underescores. The `name` for a Field must be unique and cannot be changed once created. Max length: 50. |
| `fields[].self` | string \| null (url) |  | The API show URL at which the object is accessible. Read-only. |
| `fields[].summary` | string \| null |  | A short-form, server-generated string that provides succinct, important information about an object suitable for primary labeling of an entity in a client. In many cases, this will be identical to `display_name`. Read-only. |
| `fields[].type` | string |  | Read-only. One of: `field`. |
| `fields[].updated_at` | string (date-time) |  | The date/time the object was updated at. |

Example: Response Example (Default)

```json
{
  "fields": [
    {
      "created_at": "2023-01-01T00:00:00Z",
      "data_type": "string",
      "description": "The environment that the service operates in",
      "display_name": "Environment",
      "enabled": true,
      "field_type": "single_value_fixed",
      "id": "ABCDEF1",
      "name": "environment",
      "self": "https://api.pagerduty.com/services/custom_fields/ABCDEF1",
      "summary": "Environment",
      "type": "custom_fields_field",
      "updated_at": "2023-01-01T00:00:00Z"
    },
    {
      "created_at": "2023-01-01T00:00:00Z",
      "data_type": "string",
      "description": "The regions where this service is deployed",
      "display_name": "Supported Regions",
      "enabled": true,
      "field_type": "multi_value_fixed",
      "id": "ABCDEF2",
      "name": "supported_regions",
      "self": "https://api.pagerduty.com/services/custom_fields/ABCDEF2",
      "summary": "Supported Regions",
      "type": "custom_fields_field",
      "updated_at": "2023-01-01T00:00:00Z"
    },
    {
      "created_at": "2023-01-01T00:00:00Z",
      "data_type": "string",
      "description": "The team that owns this service",
      "display_name": "Team Owner",
      "enabled": true,
      "field_type": "single_value",
      "id": "ABCDEF3",
      "name": "team_owner",
      "self": "https://api.pagerduty.com/services/custom_fields/ABCDEF3",
      "summary": "Team Owner",
      "type": "custom_fields_field",
      "updated_at": "2023-01-01T00:00:00Z"
    }
  ]
}
```

Example: Response Example (With field_options included)

```json
{
  "fields": [
    {
      "created_at": "2023-01-01T00:00:00Z",
      "data_type": "string",
      "description": "The environment that the service operates in",
      "display_name": "Environment",
      "enabled": true,
      "field_options": [
        {
          "created_at": "2023-01-01T00:00:00Z",
          "data": {
            "data_type": "string",
            "value": "production"
          },
          "id": "OPT1",
          "type": "field_option",
          "updated_at": "2023-01-01T00:00:00Z"
        },
        {
          "created_at": "2023-01-01T00:00:00Z",
          "data": {
            "data_type": "string",
            "value": "staging"
          },
          "id": "OPT2",
          "type": "field_option",
          "updated_at": "2023-01-01T00:00:00Z"
        },
        {
          "created_at": "2023-01-01T00:00:00Z",
          "data": {
            "data_type": "string",
            "value": "development"
          },
          "id": "OPT3",
          "type": "field_option",
          "updated_at": "2023-01-01T00:00:00Z"
        }
      ],
      "field_type": "single_value_fixed",
      "id": "ABCDEF1",
      "name": "environment",
      "self": "https://api.pagerduty.com/services/custom_fields/ABCDEF1",
      "summary": "Environment",
      "type": "custom_fields_field",
      "updated_at": "2023-01-01T00:00:00Z"
    },
    {
      "created_at": "2023-01-01T00:00:00Z",
      "data_type": "string",
      "description": "The regions where this service is deployed",
      "display_name": "Supported Regions",
      "enabled": true,
      "field_options": [
        {
          "created_at": "2023-01-01T00:00:00Z",
          "data": {
            "data_type": "string",
            "value": "us-east-1"
          },
          "id": "OPT4",
          "type": "field_option",
          "updated_at": "2023-01-01T00:00:00Z"
        },
        {
          "created_at": "2023-01-01T00:00:00Z",
          "data": {
            "data_type": "string",
            "value": "us-west-1"
          },
          "id": "OPT5",
          "type": "field_option",
          "updated_at": "2023-01-01T00:00:00Z"
        },
        {
          "created_at": "2023-01-01T00:00:00Z",
          "data": {
            "data_type": "string",
            "value": "eu-west-1"
          },
          "id": "OPT6",
          "type": "field_option",
          "updated_at": "2023-01-01T00:00:00Z"
        },
        {
          "created_at": "2023-01-01T00:00:00Z",
          "data": {
            "data_type": "string",
            "value": "ap-southeast-1"
          },
          "id": "OPT7",
          "type": "field_option",
          "updated_at": "2023-01-01T00:00:00Z"
        }
      ],
      "field_type": "multi_value_fixed",
      "id": "ABCDEF2",
      "name": "supported_regions",
      "self": "https://api.pagerduty.com/services/custom_fields/ABCDEF2",
      "summary": "Supported Regions",
      "type": "custom_fields_field",
      "updated_at": "2023-01-01T00:00:00Z"
    },
    {
      "created_at": "2023-01-01T00:00:00Z",
      "data_type": "string",
      "description": "The team that owns this service",
      "display_name": "Team Owner",
      "enabled": true,
      "field_type": "single_value",
      "id": "ABCDEF3",
      "name": "team_owner",
      "self": "https://api.pagerduty.com/services/custom_fields/ABCDEF3",
      "summary": "Team Owner",
      "type": "custom_fields_field",
      "updated_at": "2023-01-01T00:00:00Z"
    }
  ]
}
```

## Response 400

Caller provided invalid arguments. Please review the response for error details. Retrying with the same arguments will *not* work.

### `application/json`

| Field | Type | Required | Description |
|---|---|---|---|
| `error` | object |  |  |
| `error.code` | integer |  | Read-only. |
| `error.message` | string |  | Error message string. Read-only. |
| `error.errors` | array of string |  | Read-only. |

## Response 500

Internal Server Error the PagerDuty server experienced an error.

### `application/json`

| Field | Type | Required | Description |
|---|---|---|---|
| `error` | object |  |  |
| `error.code` | integer |  | Read-only. |
| `error.message` | string |  | Error message string. Read-only. |
| `error.errors` | array of string |  | Read-only. |

## Developer Agreement

Your access to and use of the PagerDuty Developer Services is governed by the [PagerDuty Developer Agreement](https://docs.pagerduty.com/developer/pagerduty-developer-agreement).
